%% hallway4

%%

clear, close all
pts = [ 0 0 0; 0 100 0; 10 0 0; 10 100 0];
N = 4;
hpts = [pts  ones(N,1)];

up = [0 0 1];
cam.pos = [5 -10 2];
cam.target = [5 20 0];
cam = cam_obj(cam);

T = cam.T

%%


[imgpt invpt] = cam_plot(cam,pts);
plot(imgpt(1:2,1),imgpt(1:2,2),'g');
hold on;
plot(imgpt(3:4,1),imgpt(3:4,2),'r');
plot(0,0,'ko','MarkerSize',5);
hold off
axis equal
% calculate vanishing point
vp = intersect(imgpt(1:2,:),imgpt(3:4,:),'kx')

vpx = T(1,2)/T(3,2)
vpy = T(2,2)/T(3,2)

%%


% test back-projection (1)
% pn = [a b c d]
%  k = [imgpt 1]
%  p = pos + q k
pn = [0 0 1 0];
pos = [cam.pos 1];
for m=1:4
    k = invpt(m,:)-cam.pos;
    q = -(pn*pos')/(pn(1:3)*k');
    pt = cam.pos + q*k;
    pt
end


%%


% testr back-projection math (2)
Tinv = [cam.Tinv; 0 0 0 1];
pw = [0 0 1 0];
pn = pw*Tinv

for m=1:4
    k = [imgpt(m,:) 1];
    q = -pn(4)/(pn(1:3)*k');
    pt = q*k;
    cam.Tinv*[pt 1]'
end

%%


% test back-projection math (3)
d = -pn(4);
M = [d 0 0 0; 0 d 0 0; 0 0 d 0; pn(1:3) 0];
Tx = Tinv*M;
for m=1:4
    k = [imgpt(m,:) 1 1];
    pth = Tx*k';
    pt(1:3) = pth(1:3)./pth(4);
    pt
end
Tx

%%

% test back projection math (4)
N = 4;
k = [imgpt ones(N,2)];
pth = k*Tx';
pt = pth(:,1:3)./repmat(pth(:,4),[1 3])



%%

% use standard MATLAB cp2tform function
base_points = pts(:,1:2);
Tf = cp2tform(imgpt,base_points,'Projective');
Tf.tdata.T

%%

% MATLAB tform transformation
out = [imgpt ones(4,1)]*Tf.tdata.T;
out = out(:,1:2)./[out(:,3) out(:,3)]

% check normalization
Tn = Tx';
scl = Tf.tdata.T(3,3)/Tn(3,4)
Tm = Tn*scl;
Tm = Tm(1:3,[1 2 4])
test = max(max(abs(Tm-Tf.tdata.T)))



%%

% plot using MATLAB camera
close all
plot3(hpts(1:2,1),hpts(1:2,2),hpts(1:2,3));
hold on
plot3(hpts(3:4,1),hpts(3:4,2),hpts(3:4,3));
camproj('Perspective');
campos(cam.pos);
camtarget(cam.target);
camva(25);
daspect([1 1 1]);
%set(gca,'ZLim',[0 2]);
axis equal
grid
hold off
Tx = view
XLim = get(gca,'XLim')
YLim = get(gca,'YLim')
ZLim = get(gca,'ZLim')
